Secrets

Gofer allows user to enter secrets on both a global and pipeline scope. This is useful for workloads that need access to secret values and want a quick, convenient way to access those secrets. Global secrets are managed by admins and can grant pipelines access to secrets shared amongst many namespaces. Pipeline secrets on the other hand are only accessible from within that specific pipeline


List all pipeline secrets

GET/api/namespaces/{namespace_id}/pipelines/{pipeline_id}/secrets

Path parameters

NameTypeRequiredDescription
namespace_idstringyesThe unique identifier for the target namespace.
pipeline_idstringyesThe unique identifier for the target pipeline.

Responses

StatusBodyDescription
200ListPipelineSecretsResponsesuccessful operation
4XXErrorError
5XXErrorError

Insert a new secret into the pipeline secret store

POST/api/namespaces/{namespace_id}/pipelines/{pipeline_id}/secrets

Path parameters

NameTypeRequiredDescription
namespace_idstringyesThe unique identifier for the target namespace.
pipeline_idstringyesThe unique identifier for the target pipeline.

Request body (required): PutPipelineSecretRequest

Responses

StatusBodyDescription
201PutPipelineSecretResponsesuccessful creation
4XXErrorError
5XXErrorError

Get pipeline secret by key

GET/api/namespaces/{namespace_id}/pipelines/{pipeline_id}/secrets/{key}

Path parameters

NameTypeRequiredDescription
keystringyesThe unique identifier for the target secret.
namespace_idstringyesThe unique identifier for the target namespace.
pipeline_idstringyesThe unique identifier for the target pipeline.

Query parameters

NameTypeRequiredDescription
include_secretbooleanyesIncludes the actual plaintext secret in the response.

Responses

StatusBodyDescription
200GetPipelineSecretResponsesuccessful operation
4XXErrorError
5XXErrorError

Delete pipeline secret by key

DELETE/api/namespaces/{namespace_id}/pipelines/{pipeline_id}/secrets/{key}

Path parameters

NameTypeRequiredDescription
keystringyesThe unique identifier for the target secret.
namespace_idstringyesThe unique identifier for the target namespace.
pipeline_idstringyesThe unique identifier for the target pipeline.

Responses

StatusBodyDescription
204nonesuccessful deletion
4XXErrorError
5XXErrorError

List all global secrets

GET/api/secrets/global

Admin tokens required.

Responses

StatusBodyDescription
200ListGlobalSecretsResponsesuccessful operation
4XXErrorError
5XXErrorError

Insert a new secret into the global secret store

POST/api/secrets/global

This route is only accessible for admin tokens.

Request body (required): PutGlobalSecretRequest

Responses

StatusBodyDescription
201PutGlobalSecretResponsesuccessful creation
4XXErrorError
5XXErrorError

Get global secret by key

GET/api/secrets/global/{key}

Admin token required.

Path parameters

NameTypeRequiredDescription
keystringyesThe unique identifier for the target secret.

Query parameters

NameTypeRequiredDescription
include_secretbooleanyesIncludes the actual plaintext secret in the response.

Responses

StatusBodyDescription
200GetGlobalSecretResponsesuccessful operation
4XXErrorError
5XXErrorError

Delete global secret by key

DELETE/api/secrets/global/{key}

This route is only accessible for admin tokens.

Path parameters

NameTypeRequiredDescription
keystringyesThe unique identifier for the target secret.

Responses

StatusBodyDescription
204nonesuccessful deletion
4XXErrorError
5XXErrorError